/*
    SDL - Simple DirectMedia Layer
    Copyright (C) 1997-2009 Sam Lantinga

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Sam Lantinga
    slouken@libsdl.org
*/
module org.libsdl.thread;

import org.libsdl.config;
import org.libsdl.stdinc;

struct SDL_Thread;

extern (C)
{
	alias uintptr_t function(void*, uint, uint function(void*), void* arg, uint, uint* threadID) pfnSDL_CurrentBeginThread;
	alias void function(uint code) pfnSDL_CurrentEndThread;

	SDL_Thread* SDL_CreateThread(int function(void*) fn, void* data, pfnSDL_CurrentBeginThread pfnBeginThread, pfnSDL_CurrentEndThread pfnEndThread);
	SDL_Thread* SDL_CreateThread(int function(void*) fn, void* data);
	Uint32 SDL_ThreadID();
	Uint32 SDL_GetThreadID(SDL_Thread* thread);
	void SDL_WaitThread(SDL_Thread* thread, int* status);
	void SDL_KillThread(SDL_Thread* thread);
}
